// OSˑ̔ėp[`(UIp)

#include <windows.h>
#include <shlobj.h>
#include <new>

#include <SDL_syswm.h>

#include "breakpoint.h"
#include "disk.h"
#include "error.h"
#include "graph.h"
#include "ini.h"
#include "mc6847.h"
#include "memory.h"
#include "movie.h"
#include "osd.h"
#include "p6v.h"
#include "pc60.h"
#include "schedule.h"
#include "tape.h"


///////////////////////////////////////////////////////////
// [J֐`
///////////////////////////////////////////////////////////
static HWND OsdGetWindowHandle();		// EBhEnh擾
static int ShowConfig( HWND );			// ݒvpeBV[g\

static BOOL OsdReadINI(  HWND, int );	// ݒǍ
static BOOL OsdWriteINI( HWND, int );	// ݒۑ

static BOOL CALLBACK OsdCnfgProc1(   HWND, UINT, WPARAM, LPARAM );
static BOOL CALLBACK OsdCnfgProc2(   HWND, UINT, WPARAM, LPARAM );
static BOOL CALLBACK OsdCnfgProc3(   HWND, UINT, WPARAM, LPARAM );
static BOOL CALLBACK OsdCnfgProc4(   HWND, UINT, WPARAM, LPARAM );
static BOOL CALLBACK OsdCnfgProc5(   HWND, UINT, WPARAM, LPARAM );
static BOOL CALLBACK OsdCnfgProcCol( HWND, UINT, WPARAM, LPARAM );
static BOOL CALLBACK OsdCnfgProcEtc( HWND, UINT, WPARAM, LPARAM );
static BOOL CALLBACK OsdCnfgProcIn(  HWND, UINT, WPARAM, LPARAM );
static BOOL CALLBACK VerInfoProc(    HWND, UINT, WPARAM, LPARAM );

static void OsdOwnerDrawBtn( HDC, RECT, COLORREF );	// I[i[h[{^ `

///////////////////////////////////////////////////////////
// dȂɃO[oϐ
///////////////////////////////////////////////////////////
static cConfig *ccfg = NULL;	// ݒIuWFNg|C^
static cConfig *ecfg = NULL;	// ݒIuWFNg|C^(ҏWp)

///////////////////////////////////////////////////////////
// |bvAbvj[\
///////////////////////////////////////////////////////////
void VM6::ShowPopupMenu( int x, int y )
{
	ccfg = cfg;
	
	// MF_BYPOSITIONp
	enum {	MSYSTEM = 1,
			MTAPE   = 2,
			MDISK   = 3,
			MCONFIG = 4,
			MDEBUG  = 5,
			MHELP   = 6
		};
	
	POINT pt;
	HWND hwnd;
	HMENU hm,hsm;
	int id;
	
	pt.x = x;
	pt.y = y;
	hwnd = OsdGetWindowHandle();
	
	if( GetMenu( hwnd ) ) return;
	
	hm  = LoadMenu( (HINSTANCE)GetWindowLong( hwnd, GWL_HINSTANCE), MAKEINTRESOURCE( ID_MENU ) );
	hsm = GetSubMenu( hm, 0 );
	
	// j[̑O
	MENUITEMINFO minfo;
	minfo.cbSize = sizeof(MENUITEMINFO);
	
	// rfILv`
	minfo.fMask      = MIIM_TYPE;
	minfo.dwTypeData = NULL;
	GetMenuItemInfo( hsm, ID_AVISAVE, MF_BYCOMMAND, &minfo );
	minfo.dwTypeData = (char *)(AVI6::IsAVI() ? MSMEN_AVI1 : MSMEN_AVI0);
	SetMenuItemInfo( hsm, ID_AVISAVE, MF_BYCOMMAND, &minfo );
	// j^[h or u[N|C^ݒ肳ĂrfILv`
	if( cfg->GetMonDisp() || bp->ExistBreakPoint() ) EnableMenuItem( hsm, ID_AVISAVE, MF_BYCOMMAND | MF_GRAYED );
	
	// vCL^
	minfo.fMask      = MIIM_TYPE;
	minfo.dwTypeData = NULL;
	GetMenuItemInfo( hsm, ID_REPLAYSAVE, MF_BYCOMMAND, &minfo );
	minfo.dwTypeData = (char *)(( REPLAY::GetStatus() == REP_RECORD ) ? MSMEN_REP1 : MSMEN_REP0);
	SetMenuItemInfo( hsm, ID_REPLAYSAVE, MF_BYCOMMAND, &minfo );
	// j^[h or u[N|C^ݒ肳Ă
	// ܂̓vCĐ烊vCL^
	if( cfg->GetMonDisp() || bp->ExistBreakPoint() || ( REPLAY::GetStatus() == REP_REPLAY ) )
		EnableMenuItem( hsm, ID_REPLAYSAVE, MF_BYCOMMAND | MF_GRAYED );
	
	// vCĐ
	minfo.fMask      = MIIM_TYPE;
	minfo.dwTypeData = NULL;
	GetMenuItemInfo( hsm, ID_REPLAYLOAD, MF_BYCOMMAND, &minfo );
	minfo.dwTypeData = (char *)(( REPLAY::GetStatus() == REP_REPLAY ) ? MSMEN_REP3: MSMEN_REP2);
	SetMenuItemInfo( hsm, ID_REPLAYLOAD, MF_BYCOMMAND, &minfo );
	// j^[h or u[N|C^ݒ肳Ă
	// ܂̓vCL^烊vCĐ
	if( cfg->GetMonDisp() || bp->ExistBreakPoint() || ( REPLAY::GetStatus() == REP_RECORD ) )
		EnableMenuItem( hsm, ID_REPLAYLOAD, MF_BYCOMMAND | MF_GRAYED );
	
	
	// TAPE
	EnableMenuItem( hsm, ID_TAPEEJECT, MF_BYCOMMAND | *cmt->GetFile() ? MF_ENABLED : MF_GRAYED );
	
	// DISK
	switch( disk->GetDrives() ){
	case 0:
		DeleteMenu( hsm, MDISK, MF_BYPOSITION );
		break;
	case 1:
		DeleteMenu( GetSubMenu( hsm, MDISK ), 1, MF_BYPOSITION );
		EnableMenuItem( hsm, ID_DISKEJECT1, MF_BYCOMMAND | *disk->GetFile(0) ? MF_ENABLED : MF_GRAYED );
		break;
	default:
		EnableMenuItem( hsm, ID_DISKEJECT1, MF_BYCOMMAND | *disk->GetFile(0) ? MF_ENABLED : MF_GRAYED );
		EnableMenuItem( hsm, ID_DISKEJECT2, MF_BYCOMMAND | *disk->GetFile(1) ? MF_ENABLED : MF_GRAYED );
	}
	
	// gROM
	EnableMenuItem( hsm, ID_ROMEJECT, MF_BYCOMMAND | (*mem->GetFile()  ? MF_ENABLED : MF_GRAYED) );
	
	// MODE4J[
	CheckMenuRadioItem( hsm, ID_M4MONO, ID_M4GRPK, ID_M4MONO + vdg->GetMode4Color(), MF_BYCOMMAND );
	
	// t[XLbv
	CheckMenuRadioItem( hsm, ID_FSKP0, ID_FSKP5, ID_FSKP0 + cfg->GetFrameSkip(), MF_BYCOMMAND );
	
	CheckMenuItem( hsm, ID_NOWAIT,   sche->GetWaitEnable() ? MF_UNCHECKED : MF_CHECKED   );
	CheckMenuItem( hsm, ID_TURBO,    cfg->GetTurboTAPE()   ? MF_CHECKED   : MF_UNCHECKED );
	CheckMenuItem( hsm, ID_BOOST,    cmt->IsBoostUp()      ? MF_CHECKED   : MF_UNCHECKED );
	CheckMenuItem( hsm, ID_SCANLINE, cfg->GetScanLine()    ? MF_CHECKED   : MF_UNCHECKED );
	CheckMenuItem( hsm, ID_DISP43,   cfg->GetDispNTSC()    ? MF_CHECKED   : MF_UNCHECKED );
	CheckMenuItem( hsm, ID_STATUS,   cfg->GetStatDisp()    ? MF_CHECKED   : MF_UNCHECKED );
	
	#ifdef USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	CheckMenuItem( hsm, ID_MONITOR,  cfg->GetMonDisp()     ? MF_CHECKED   : MF_UNCHECKED );
	CheckMenuItem( hsm, ID_TIMERINT, cfg->GetTimerIntr()   ? MF_UNCHECKED : MF_CHECKED );
	#else
	DeleteMenu( hsm, MDEBUG, MF_BYPOSITION );
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
	ClientToScreen( hwnd, &pt );
	id = TrackPopupMenu( hsm, TPM_RETURNCMD | TPM_LEFTALIGN, pt.x, pt.y, 0, hwnd, NULL );
	DestroyMenu( hm );
	
	// ڂƂ̏
	char str[PATH_MAX];
	switch( id ){
	case ID_TAPEINSERT:		// TAPE }
		if( OSD_FileSelect( hwnd, FD_TapeLoad, str, cfg->GetTapePath() ) )
			if( !TapeInsert( str ) ) Error::SetError( Error::TapeMountFailed );
		break;
		
	case ID_TAPEEJECT:		// TAPE ro
		TapeEject();
		break;
		
	case ID_DISKINSERT1:	// DISK1 }
		if( OSD_FileSelect( hwnd, FD_Disk, str, cfg->GetDiskPath() ) )
			if( !DiskInsert( 0, str ) ) Error::SetError( Error::DiskMountFailed );
		break;
		
	case ID_DISKEJECT1:		// DISK1 ro
		DiskEject( 0 );
		break;
		
	case ID_DISKINSERT2:	// DISK2 }
		if( OSD_FileSelect( hwnd, FD_Disk, str, cfg->GetDiskPath() ) )
			if( !DiskInsert( 1, str ) ) Error::SetError( Error::DiskMountFailed );
		break;
		
	case ID_DISKEJECT2:		// DISK2 ro
		DiskEject( 1 );
		break;
		
	case ID_ROMINSERT:		// gROM }
		if( OSD_FileSelect( hwnd, FD_ExtRom, str, cfg->GetExtRomPath() ) ){
			// Zbg𔺂̂ŃbZ[W\
			OSD_Message( MSG_RESETI, MSG_RESETC, OSDM_OK | OSDM_ICONINFO );
			if( !ExtRomInsert( str ) ) Error::SetError( Error::ExtRomMountFailed );
			else                       Reset();
		}
		break;
		
	case ID_ROMEJECT:		// gROM ro
		// Zbg𔺂̂ŃbZ[W\
		OSD_Message( MSG_RESETE, MSG_RESETC, OSDM_OK | OSDM_ICONINFO );
		ExtRomEject();
		Reset();
		break;
		
	case ID_CONFIG:			// ݒ
		if( ShowConfig( hwnd ) > 0 )
			// ċN?
			if( OSD_Message( MSG_RESTART, MSG_RESTARTC, OSDM_YESNO | OSDM_ICONQUESTION ) == OSDR_YES )
				SENDEVENT( SDL_RESTART )
		break;
		
	case ID_RESET:			// Zbg
		Reset();
		break;
		
	case ID_RESTART:		// ċN
		SENDEVENT( SDL_RESTART )
		break;
		
	case ID_DOKOSAVE:		// ǂłSAVE
		if( OSD_FileSelect( hwnd, FD_DokoSave, str, (char *)OSD_GetModulePath() ) )
		DokoDemoSave( str );
		break;
		
	case ID_DOKOLOAD:		// ǂłLOAD
		if( OSD_FileSelect( hwnd, FD_DokoLoad, str, (char *)OSD_GetModulePath() ) )
		DokoDemoLoad( str );
		break;
		
	case ID_REPLAYSAVE:		// vCۑ
		if( REPLAY::GetStatus() == REP_IDLE ){
			if( OSD_FileSelect( hwnd, FD_RepSave, str, (char *)OSD_GetModulePath() ) ){
				if( DokoDemoSave( str ) ) REPLAY::StartRecord( str );
			}
		}else if( REPLAY::GetStatus() == REP_RECORD ){
			REPLAY::StopRecord();
		}
		break;
		
	case ID_REPLAYLOAD:		// vCĐ
		if( REPLAY::GetStatus() == REP_IDLE ){
			if( OSD_FileSelect( hwnd, FD_RepLoad, str, (char *)OSD_GetModulePath() ) ){
				if( DokoDemoLoad( str ) )
					REPLAY::StartReplay( str );
				else
					if( Error::GetError() == Error::DokoDiffModel ) Error::SetError( Error::ReplayDiffModel );
			}
		}else if( REPLAY::GetStatus() == REP_REPLAY ){
			REPLAY::StopReplay();
		}
		break;
		
	case ID_AVISAVE:		// rfILv`
		if( !AVI6::IsAVI() ){
			if( OSD_FileSelect( hwnd, FD_AVISave, str, (char *)OSD_GetModulePath() ) ){
				AVI6::StartAVI( str, graph->ScreenX(), graph->ScreenY(), FRAMERATE, cfg->GetSampleRate(), cfg->GetScrBpp(), cfg->GetAviRle() );
			}
		}else{
			AVI6::StopAVI();
		}
		break;
		
	case ID_AUTOTYPE:		// ōݑs
		if( OSD_FileSelect( hwnd, FD_LoadAll, str, (char *)OSD_GetModulePath() ) )
		if( !AutoType( str ) ) Error::SetError( Error::Unknown );
		break;
		
	case ID_QUIT:			// I
		SENDEVENT( SDL_QUIT )
		break;
		
	case ID_NOWAIT:			// WaitLύX
		sche->SetWaitEnable( sche->GetWaitEnable() ? FALSE : TRUE );
		break;
		
	case ID_TURBO:			// Turbo TAPE
		cfg->SetTurboTAPE( cfg->GetTurboTAPE() ? FALSE : TRUE );
		break;
		
	case ID_BOOST:			// Boost Up
		cfg->SetBoostUp( cfg->GetBoostUp() ? FALSE : TRUE );
		cmt->SetBoost( cmt->IsBoostUp() ? FALSE : TRUE );
		break;
		
	case ID_SCANLINE:		// XLC[hύX
		// rfILv`͖
		if( !AVI6::IsAVI() ){
			cfg->SetScanLine( cfg->GetScanLine() ? FALSE : TRUE );
			graph->ResizeScreen();	// XN[TCYύX
		}
		break;
		
	case ID_DISP43:			// 4:3\ύX
		// rfILv`͖
		if( !AVI6::IsAVI() ){
			cfg->SetDispNTSC( cfg->GetDispNTSC() ? FALSE : TRUE );
			graph->ResizeScreen();	// XN[TCYύX
		}
		break;
		
	case ID_STATUS:			// Xe[^Xo[\ԕύX
		cfg->SetStatDisp( cfg->GetStatDisp() ? FALSE : TRUE );
		graph->ResizeScreen();	// XN[TCYύX
		break;
		
							// MODE4J[
	case ID_M4MONO:		// mN
		cfg->SetMode4Color( 0 );
		vdg->SetMode4Color( 0 );
		break;
	case ID_M4RDBL:		// /
		cfg->SetMode4Color( 1 );
		vdg->SetMode4Color( 1 );
		break;
	case ID_M4BLRD:		// /
		cfg->SetMode4Color( 2 );
		vdg->SetMode4Color( 2 );
		break;
	case ID_M4PKGR:		// sN/
		cfg->SetMode4Color( 3 );
		vdg->SetMode4Color( 3 );
		break;
	case ID_M4GRPK:		// /sN
		cfg->SetMode4Color( 4 );
		vdg->SetMode4Color( 4 );
		break;
		
							// t[XLbv
							// rfILv`͖
	case ID_FSKP0:		// 0
		if( !AVI6::IsAVI() ) cfg->SetFrameSkip( 0 );
		break;
	case ID_FSKP1:		// 1
		if( !AVI6::IsAVI() ) cfg->SetFrameSkip( 1 );
		break;
	case ID_FSKP2:		// 2
		if( !AVI6::IsAVI() ) cfg->SetFrameSkip( 2 );
		break;
	case ID_FSKP3:		// 3
		if( !AVI6::IsAVI() ) cfg->SetFrameSkip( 3 );
		break;
	case ID_FSKP4:		// 4
		if( !AVI6::IsAVI() ) cfg->SetFrameSkip( 4 );
		break;
	case ID_FSKP5:		// 5
		if( !AVI6::IsAVI() ) cfg->SetFrameSkip( 5 );
		break;
		
	#ifdef USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	case ID_MONITOR:		// j^[[h
		ToggleMonitor();
		break;
		
	case ID_TIMERINT:		// ^C}݋
		cfg->SetTimerIntr( cfg->GetTimerIntr() ? FALSE : TRUE );
		break;
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
		
	case ID_VERSION:		// o[W
		DialogBox( (HINSTANCE)GetWindowLong( hwnd, GWL_HINSTANCE), MAKEINTRESOURCE(ID_VER), hwnd, (DLGPROC)VerInfoProc );
		break;
	}
}


///////////////////////////////////////////////////////////
// EBhEnh擾
///////////////////////////////////////////////////////////
static HWND OsdGetWindowHandle( void )
{
	SDL_SysWMinfo WinInfo;
	
	SDL_VERSION( &WinInfo.version );
  	if( SDL_GetWMInfo( &WinInfo ) ) return WinInfo.window;
	else                            return NULL;
}


///////////////////////////////////////////////////////////
// ݒvpeBV[g\
///////////////////////////////////////////////////////////
static int ShowConfig( HWND hwnd )
{
	// INIt@CJ
	try{
		ecfg = new cConfig();
		if( !ecfg->Init() ) throw Error::IniReadFailed;
	}
	// new Ɏsꍇ
	catch( std::bad_alloc ){
		return -1;
	}
	// O
	catch( Error::Errno i ){
		delete ecfg;
		ecfg = NULL;
		return -1;
	}
	
	
	// y[W̐ݒsȂ
	PROPSHEETPAGE psp[9];
	PROPSHEETHEADER psh;
	
	// {
	psp[0].dwSize      = sizeof(PROPSHEETPAGE);
	psp[0].dwFlags     = PSP_DEFAULT;
	psp[0].hInstance   = (HINSTANCE)GetWindowLong( hwnd, GWL_HINSTANCE);
	psp[0].pszTemplate = MAKEINTRESOURCE(ID_CNFG1);
	psp[0].pszIcon     = NULL;
	psp[0].pfnDlgProc  = (DLGPROC)OsdCnfgProc1;
	psp[0].pszTitle    = NULL;
	psp[0].lParam      = 0;
	
	// 
	psp[1].dwSize      = sizeof(PROPSHEETPAGE);
	psp[1].dwFlags     = PSP_DEFAULT;
	psp[1].hInstance   = (HINSTANCE)GetWindowLong( hwnd, GWL_HINSTANCE);
	psp[1].pszTemplate = MAKEINTRESOURCE(ID_CNFG2);
	psp[1].pszIcon     = NULL;
	psp[1].pfnDlgProc  = (DLGPROC)OsdCnfgProc2;
	psp[1].pszTitle    = NULL;
	psp[1].lParam      = 0;
	
	// TEh
	psp[2].dwSize      = sizeof(PROPSHEETPAGE);
	psp[2].dwFlags     = PSP_DEFAULT;
	psp[2].hInstance   = (HINSTANCE)GetWindowLong( hwnd, GWL_HINSTANCE);
	psp[2].pszTemplate = MAKEINTRESOURCE(ID_CNFG3);
	psp[2].pszIcon     = NULL;
	psp[2].pfnDlgProc  = (DLGPROC)OsdCnfgProc3;
	psp[2].pszTitle    = NULL;
	psp[2].lParam      = 0;
	
	// ͊֌W
	psp[3].dwSize      = sizeof(PROPSHEETPAGE);
	psp[3].dwFlags     = PSP_DEFAULT;
	psp[3].hInstance   = (HINSTANCE)GetWindowLong( hwnd, GWL_HINSTANCE);
	psp[3].pszTemplate = MAKEINTRESOURCE(ID_CNFGIN);
	psp[3].pszIcon     = NULL;
	psp[3].pfnDlgProc  = (DLGPROC)OsdCnfgProcIn;
	psp[3].pszTitle    = NULL;
	psp[3].lParam      = 0;
	
	// t@C
	psp[4].dwSize      = sizeof(PROPSHEETPAGE);
	psp[4].dwFlags     = PSP_DEFAULT;
	psp[4].hInstance   = (HINSTANCE)GetWindowLong( hwnd, GWL_HINSTANCE);
	psp[4].pszTemplate = MAKEINTRESOURCE(ID_CNFG4);
	psp[4].pszIcon     = NULL;
	psp[4].pfnDlgProc  = (DLGPROC)OsdCnfgProc4;
	psp[4].pszTitle    = NULL;
	psp[4].lParam      = 0;
	
	// tH_
	psp[5].dwSize      = sizeof(PROPSHEETPAGE);
	psp[5].dwFlags     = PSP_DEFAULT;
	psp[5].hInstance   = (HINSTANCE)GetWindowLong( hwnd, GWL_HINSTANCE);
	psp[5].pszTemplate = MAKEINTRESOURCE(ID_CNFG5);
	psp[5].pszIcon     = NULL;
	psp[5].pfnDlgProc  = (DLGPROC)OsdCnfgProc5;
	psp[5].pszTitle    = NULL;
	psp[5].lParam      = 0;
	
	// F1
	psp[6].dwSize      = sizeof(PROPSHEETPAGE);
	psp[6].dwFlags     = PSP_DEFAULT;
	psp[6].hInstance   = (HINSTANCE)GetWindowLong( hwnd, GWL_HINSTANCE);
	psp[6].pszTemplate = MAKEINTRESOURCE(ID_CNFGCL1);
	psp[6].pszIcon     = NULL;
	psp[6].pfnDlgProc  = (DLGPROC)OsdCnfgProcCol;
	psp[6].pszTitle    = NULL;
	psp[6].lParam      = 0;
	
	// F2
	psp[7].dwSize      = sizeof(PROPSHEETPAGE);
	psp[7].dwFlags     = PSP_DEFAULT;
	psp[7].hInstance   = (HINSTANCE)GetWindowLong( hwnd, GWL_HINSTANCE);
	psp[7].pszTemplate = MAKEINTRESOURCE(ID_CNFGCL2);
	psp[7].pszIcon     = NULL;
	psp[7].pfnDlgProc  = (DLGPROC)OsdCnfgProcCol;
	psp[7].pszTitle    = NULL;
	psp[7].lParam      = 0;
	
	// ̑
	psp[8].dwSize      = sizeof(PROPSHEETPAGE);
	psp[8].dwFlags     = PSP_DEFAULT;
	psp[8].hInstance   = (HINSTANCE)GetWindowLong( hwnd, GWL_HINSTANCE);
	psp[8].pszTemplate = MAKEINTRESOURCE(ID_CNFGETC);
	psp[8].pszIcon     = NULL;
	psp[8].pfnDlgProc  = (DLGPROC)OsdCnfgProcEtc;
	psp[8].pszTitle    = NULL;
	psp[8].lParam      = 0;
	
	
	psh.dwSize     = sizeof(PROPSHEETHEADER);
	psh.dwFlags    = PSH_PROPSHEETPAGE | PSH_NOAPPLYNOW;
	psh.hwndParent = hwnd;
	psh.hInstance  = (HINSTANCE)GetWindowLong( hwnd, GWL_HINSTANCE);
	psh.pszIcon    = NULL;
	psh.pszCaption = (LPSTR) "ݒ";
	psh.nPages     = sizeof(psp) / sizeof(PROPSHEETPAGE);
	psh.nStartPage = 0;
	psh.ppsp       = (LPCPROPSHEETPAGE) &psp;
	
	// vpeBV[g\
	int ret = PropertySheet( &psh );
	// ret 1:OK 0:CANCEL
	
	// OK{^ꂽȂINIt@C
	if( ret > 0) ecfg->Write();
	
	delete ecfg;
	ecfg = NULL;
	
	return ret;
}


enum { PP_BASE, PP_DISP, PP_SOUND, PP_FILE, PP_FOLDER, PP_COL, PP_ETC, PP_INPUT };

///////////////////////////////////////////////////////////
// ݒǍ
///////////////////////////////////////////////////////////
static BOOL OsdReadINI( HWND hwnd, int page )
{
	int st;					// Ԏ擾p
	BOOL yn;				// Ԏ擾p
	char str[PATH_MAX];		// 擾p
	
	if( !ecfg ) return FALSE;
	
	switch( page ){
	case PP_BASE:	// {
		// @
		st = ecfg->GetModel();
		SendMessage( GetDlgItem( hwnd, ID_RB01 ), BM_SETCHECK, (st==60)? BST_CHECKED:BST_UNCHECKED, 0 );
		SendMessage( GetDlgItem( hwnd, ID_RB02 ), BM_SETCHECK, (st==62)? BST_CHECKED:BST_UNCHECKED, 0 );
		SendMessage( GetDlgItem( hwnd, ID_RB03 ), BM_SETCHECK, (st==66)? BST_CHECKED:BST_UNCHECKED, 0 );
		SendMessage( GetDlgItem( hwnd, ID_RB04 ), BM_SETCHECK, (st==64)? BST_CHECKED:BST_UNCHECKED, 0 );
		SendMessage( GetDlgItem( hwnd, ID_RB05 ), BM_SETCHECK, (st==68)? BST_CHECKED:BST_UNCHECKED, 0 );
		
		// FDD
		st = ecfg->GetFddNum();
		SendMessage( GetDlgItem( hwnd, ID_RB31 ), BM_SETCHECK, (st==0)? BST_CHECKED:BST_UNCHECKED, 0 );
		SendMessage( GetDlgItem( hwnd, ID_RB32 ), BM_SETCHECK, (st==1)? BST_CHECKED:BST_UNCHECKED, 0 );
		SendMessage( GetDlgItem( hwnd, ID_RB33 ), BM_SETCHECK, (st==2)? BST_CHECKED:BST_UNCHECKED, 0 );
		
		// gRAMgp
		yn = ecfg->GetUseExtRam();
		SendMessage( GetDlgItem( hwnd, ID_CB1 ), BM_SETCHECK, yn, 0 );
		
		// m̃J[gbWgp
		yn = ecfg->GetUseSoldier();
		SendMessage( GetDlgItem( hwnd, ID_CB13 ), BM_SETCHECK, yn, 0 );
		
		break;
		
	case PP_DISP:	// 
		// J[[h
		st = ecfg->GetScrBpp();
		SendMessage( GetDlgItem( hwnd, ID_RB34 ), BM_SETCHECK, (st== 8)? BST_CHECKED:BST_UNCHECKED, 0 );
		SendMessage( GetDlgItem( hwnd, ID_RB35 ), BM_SETCHECK, (st==16)? BST_CHECKED:BST_UNCHECKED, 0 );
		SendMessage( GetDlgItem( hwnd, ID_RB36 ), BM_SETCHECK, (st==24)? BST_CHECKED:BST_UNCHECKED, 0 );
		
		// MODE4J[
		st = ecfg->GetMode4Color();
		SendMessage( GetDlgItem( hwnd, ID_RB11 ), BM_SETCHECK, (st==0)? BST_CHECKED:BST_UNCHECKED, 0 );
		SendMessage( GetDlgItem( hwnd, ID_RB12 ), BM_SETCHECK, (st==1)? BST_CHECKED:BST_UNCHECKED, 0 );
		SendMessage( GetDlgItem( hwnd, ID_RB13 ), BM_SETCHECK, (st==2)? BST_CHECKED:BST_UNCHECKED, 0 );
		SendMessage( GetDlgItem( hwnd, ID_RB14 ), BM_SETCHECK, (st==3)? BST_CHECKED:BST_UNCHECKED, 0 );
		SendMessage( GetDlgItem( hwnd, ID_RB15 ), BM_SETCHECK, (st==4)? BST_CHECKED:BST_UNCHECKED, 0 );
		
		// XLC
		yn = ecfg->GetScanLine();
		SendMessage( GetDlgItem( hwnd, ID_CB2 ), BM_SETCHECK, yn, 0 );
		
		// XLCPx
		st = ecfg->GetScanLineBr();
		sprintf( str, "%d", st );
		SetDlgItemText( hwnd, ID_SCANLINEBR, str );
		
		// 4:3\
		yn = ecfg->GetDispNTSC();
		SendMessage( GetDlgItem( hwnd, ID_CB7 ), BM_SETCHECK, yn, 0 );
		
		// tXN[
		yn = ecfg->GetFullScreen();
		SendMessage( GetDlgItem( hwnd, ID_CB10 ), BM_SETCHECK, yn, 0 );
		
		// Xe[^Xo[\
		yn = ecfg->GetStatDisp();
		SendMessage( GetDlgItem( hwnd, ID_CB11 ), BM_SETCHECK, yn, 0 );
		
		// t[XLbv
		st = ecfg->GetFrameSkip();
		SendMessage( GetDlgItem( hwnd, ID_TBFPS ), TBM_SETPOS, TRUE, st );
		SendMessage( GetDlgItem( hwnd, ID_TBFPS ), TBM_SETTHUMBLENGTH, 12, 0 );
		SendMessage( GetDlgItem( hwnd, ID_TBFPS ), TBM_SETRANGE, TRUE, MAKELPARAM(0,5) );
		
		break;
		
	case PP_SOUND:	// TEh
		// TvO[g
		st = ecfg->GetSampleRate();
		SendMessage( GetDlgItem( hwnd, ID_RB21 ), BM_SETCHECK, (st==44100)? BST_CHECKED:BST_UNCHECKED, 0 );
		SendMessage( GetDlgItem( hwnd, ID_RB22 ), BM_SETCHECK, (st==22050)? BST_CHECKED:BST_UNCHECKED, 0 );
		SendMessage( GetDlgItem( hwnd, ID_RB23 ), BM_SETCHECK, (st==11025)? BST_CHECKED:BST_UNCHECKED, 0 );
		
		// obt@TCY
		st = ecfg->GetSoundBuffer();
		SendMessage( GetDlgItem( hwnd, ID_TBBUF ), TBM_SETPOS, TRUE, st );
		SendMessage( GetDlgItem( hwnd, ID_TBBUF ), TBM_SETTHUMBLENGTH, 12, 0 );
		SendMessage( GetDlgItem( hwnd, ID_TBBUF ), TBM_SETRANGE, TRUE, MAKELPARAM(1,5) );
		
		// PSG LPFJbgItg
		st = ecfg->GetPsgLPF();
		sprintf( str, "%d", st );
		SetDlgItemText( hwnd, ID_EDIT1, str );
		
		// }X^[
		st = ecfg->GetMasterVol();
		SendMessage( GetDlgItem( hwnd, ID_TBMST ), TBM_SETPOS, TRUE, st/10 );
		SendMessage( GetDlgItem( hwnd, ID_TBMST ), TBM_SETTHUMBLENGTH, 12, 0 );
		SendMessage( GetDlgItem( hwnd, ID_TBMST ), TBM_SETRANGE, TRUE, MAKELPARAM(0,10) );
		
		// PSG
		st = ecfg->GetPsgVol();
		SendMessage( GetDlgItem( hwnd, ID_TBPSG ), TBM_SETPOS, TRUE, st/10 );
		SendMessage( GetDlgItem( hwnd, ID_TBPSG ), TBM_SETTHUMBLENGTH, 12, 0 );
		SendMessage( GetDlgItem( hwnd, ID_TBPSG ), TBM_SETRANGE, TRUE, MAKELPARAM(0,10) );
		
		// 
		st = ecfg->GetVoiceVol();
		SendMessage( GetDlgItem( hwnd, ID_TBVCE ), TBM_SETPOS, TRUE, st/10 );
		SendMessage( GetDlgItem( hwnd, ID_TBVCE ), TBM_SETTHUMBLENGTH, 12, 0 );
		SendMessage( GetDlgItem( hwnd, ID_TBVCE ), TBM_SETRANGE, TRUE, MAKELPARAM(0,10) );
		
		// TAPEj^
		st = ecfg->GetCmtVol();
		SendMessage( GetDlgItem( hwnd, ID_TBTAPE ), TBM_SETPOS, TRUE, st/10 );
		SendMessage( GetDlgItem( hwnd, ID_TBTAPE ), TBM_SETTHUMBLENGTH, 12, 0 );
		SendMessage( GetDlgItem( hwnd, ID_TBTAPE ), TBM_SETRANGE, TRUE, MAKELPARAM(0,10) );
		
		break;
		
	case PP_INPUT:	// ͊֌W
		// L[s[gԊu
		st = ecfg->GetKeyRepeat();
		sprintf( str, "%d", st );
		SetDlgItemText( hwnd, ID_KEYREP, str );
		
		break;
		
	case PP_FOLDER:	// tH_
		// ROMpX
		strncpy( str, ecfg->GetRomPath(), PATH_MAX );
		DelDelimiter( str );
		UnDelimiter( str );
		SetDlgItemText( hwnd, ID_PATH1, str );
		
		// TAPEpX
		strncpy( str, ecfg->GetTapePath(), PATH_MAX );
		DelDelimiter( str );
		UnDelimiter( str );
		SetDlgItemText( hwnd, ID_PATH2, str );
		
		// DISKpX
		strncpy( str, ecfg->GetDiskPath(), PATH_MAX );
		DelDelimiter( str );
		UnDelimiter( str );
		SetDlgItemText( hwnd, ID_PATH3, str );
		
		// gROMpX
		strncpy( str, ecfg->GetExtRomPath(), PATH_MAX );
		DelDelimiter( str );
		UnDelimiter( str );
		SetDlgItemText( hwnd, ID_PATH4, str );
		
		// IMGpX
		strncpy( str, ecfg->GetImgPath(), PATH_MAX );
		DelDelimiter( str );
		UnDelimiter( str );
		SetDlgItemText( hwnd, ID_PATH5, str );
		
		// WAVEpX
		strncpy( str, ecfg->GetWavePath(), PATH_MAX );
		DelDelimiter( str );
		UnDelimiter( str );
		SetDlgItemText( hwnd, ID_PATH6, str );
		
		// FONTpX
		strncpy( str, ecfg->GetFontPath(), PATH_MAX );
		DelDelimiter( str );
		UnDelimiter( str );
		SetDlgItemText( hwnd, ID_PATH7, str );
		
		break;
		
	case PP_FILE:	// t@C
		// gROMt@C
		strncpy( str, ecfg->GetExtRomFile(), PATH_MAX );
		UnDelimiter( str );
		SetDlgItemText( hwnd, ID_FEXROM, str );
		
		// TAPE(LOAD)t@C
		strncpy( str, ecfg->GetTapeFile(), PATH_MAX );
		UnDelimiter( str );
		SetDlgItemText( hwnd, ID_FTPLD, str );
		
		// TAPE(SAVE)t@C
		strncpy( str, ecfg->GetSaveFile(), PATH_MAX );
		UnDelimiter( str );
		SetDlgItemText( hwnd, ID_FTPSV, str );
		
		// DISKt@C
		strncpy( str, ecfg->GetDiskFile(), PATH_MAX );
		UnDelimiter( str );
		SetDlgItemText( hwnd, ID_FDISK, str );
		
		// v^t@C
		strncpy( str, ecfg->GetPrinterFile(), PATH_MAX );
		UnDelimiter( str );
		SetDlgItemText( hwnd, ID_FPRINT, str );
		
		// SptHgt@C
		strncpy( str, ecfg->GetFontFileZ(), PATH_MAX );
		UnDelimiter( str );
		SetDlgItemText( hwnd, ID_FFONTZ, str );
		
		// ptHgt@C
		strncpy( str, ecfg->GetFontFileH(), PATH_MAX );
		UnDelimiter( str );
		SetDlgItemText( hwnd, ID_FFONTH, str );
		
		break;
		
	case PP_COL:	// F1
		break;
		
	case PP_ETC:	// ̑
		// I[o[NbN
		st = min( max( 1, ecfg->GetOverClock() ), 1000 );
		sprintf( str, "%d", st );
		SetDlgItemText( hwnd, ID_OVERCLK, str );
		
		// CRC`FbN
		yn = ecfg->GetCheckCRC();
		SendMessage( GetDlgItem( hwnd, ID_CB4 ), BM_SETCHECK, yn, 0 );
		
		// ROMpb`
		yn = ecfg->GetRomPatch();
		SendMessage( GetDlgItem( hwnd, ID_CB9 ), BM_SETCHECK, yn, 0 );
		
		// Turbo TAPE
		yn = ecfg->GetTurboTAPE();
		SendMessage( GetDlgItem( hwnd, ID_CB3 ), BM_SETCHECK, yn, 0 );
		
		// Boost Up
		yn = ecfg->GetBoostUp();
		SendMessage( GetDlgItem( hwnd, ID_CB5 ), BM_SETCHECK, yn, 0 );
		
		// BoostUp ő{(N60[h)
		st = min( max( 1, ecfg->GetMaxBoost1() ), 100 );
		sprintf( str, "%d", st );
		SetDlgItemText( hwnd, ID_BOOST60, str );
		
		// BoostUp ő{(N60m/N66[h)
		st = min( max( 1, ecfg->GetMaxBoost2() ), 100 );
		sprintf( str, "%d", st );
		SetDlgItemText( hwnd, ID_BOOST62, str );
		
		// rfILv` RLE
		yn = ecfg->GetAviRle();
		SendMessage( GetDlgItem( hwnd, ID_CB6 ), BM_SETCHECK, yn, 0 );
		
		// I mF
		yn = ecfg->GetCkQuit();
		SendMessage( GetDlgItem( hwnd, ID_CB8 ), BM_SETCHECK, yn, 0 );
		
		// I INIt@Cۑ
		yn = ecfg->GetSaveQuit();
		SendMessage( GetDlgItem( hwnd, ID_CB12 ), BM_SETCHECK, yn, 0 );
		
		break;
	}
	
	return TRUE;
}


///////////////////////////////////////////////////////////
// ݒۑ
///////////////////////////////////////////////////////////
static BOOL OsdWriteINI( HWND hwnd, int page )
{
	int st;					// Ԏ擾p
	char str[PATH_MAX];		// 擾p
	
	if( !ecfg ) return FALSE;
	
	switch( page ){
	case PP_BASE:	// {
		// @
		if     ( IsDlgButtonChecked( hwnd, ID_RB02 ) ) st = 62;	// PC-6001mk2
		else if( IsDlgButtonChecked( hwnd, ID_RB03 ) ) st = 66;	// PC-6601
		else if( IsDlgButtonChecked( hwnd, ID_RB04 ) ) st = 64;	// PC-6001mk2SR
		else if( IsDlgButtonChecked( hwnd, ID_RB05 ) ) st = 68;	// PC-6601SR
		else                                           st = 60;	// LȊOȂPC-6001
		ecfg->SetModel( st );
		
		// FDD
		if     ( IsDlgButtonChecked( hwnd, ID_RB32 ) ) st = 1;		// 2
		else if( IsDlgButtonChecked( hwnd, ID_RB33 ) ) st = 2;		// 1
		else                                           st = 0;		// LȊOȂȂ
		ecfg->SetFddNum( st );
		
		// gRAMgp
		ecfg->SetUseExtRam( IsDlgButtonChecked( hwnd, ID_CB1 ) );
		
		// m̃J[gbWgp
		ecfg->SetUseSoldier( IsDlgButtonChecked( hwnd, ID_CB13 ) );
		
		break;
		
	case PP_DISP:	// 
		// J[[h
		if     ( IsDlgButtonChecked( hwnd, ID_RB36 ) ) st = 24;	// 24bit
		else if( IsDlgButtonChecked( hwnd, ID_RB35 ) ) st = 16;	// 16bit
		else                                           st =  8;	// LȊOȂ8bit
		ecfg->SetScrBpp( st );
		
		// MODE4J[
		if     ( IsDlgButtonChecked( hwnd, ID_RB12 ) ) st = 1;	// /
		else if( IsDlgButtonChecked( hwnd, ID_RB13 ) ) st = 2;	// /
		else if( IsDlgButtonChecked( hwnd, ID_RB14 ) ) st = 3;	// sN/
		else if( IsDlgButtonChecked( hwnd, ID_RB15 ) ) st = 4;	// /sN
		else                                           st = 0;	// LȊOȂ烂mN
		ecfg->SetMode4Color( st );
		
		// XLC
		ecfg->SetScanLine( IsDlgButtonChecked( hwnd, ID_CB2 ) );
		
		// XLCPx
		GetDlgItemText( hwnd, ID_SCANLINEBR, str, sizeof(str) );
		st = strtol( str, NULL, 0 );
		ecfg->SetScanLineBr( st );
		
		// 4:3\
		ecfg->SetDispNTSC( IsDlgButtonChecked( hwnd, ID_CB7 ) );
		
		// tXN[
		ecfg->SetFullScreen( IsDlgButtonChecked( hwnd, ID_CB10 ) );
		
		// Xe[^Xo[\
		ecfg->SetStatDisp( IsDlgButtonChecked( hwnd, ID_CB11 ) );
		
		// t[XLbv
		st = SendMessage( GetDlgItem( hwnd, ID_TBFPS ), TBM_GETPOS, 0, 0 );
		ecfg->SetFrameSkip( st );
		
		break;
		
	case PP_SOUND:	// TEh
		// TvO[g
		if     ( IsDlgButtonChecked( hwnd, ID_RB22 ) ) st = 22050;	// 22050
		else if( IsDlgButtonChecked( hwnd, ID_RB23 ) ) st = 11025;	// 11025
		else                                           st = 44100;	// LȊOȂ44100
		ecfg->SetSampleRate( st );
		
		// obt@TCY
		st = SendMessage( GetDlgItem( hwnd, ID_TBBUF ), TBM_GETPOS, 0, 0 );
		ecfg->SetSoundBuffer( st );
		
		// PSG LPFJbgItg
		GetDlgItemText( hwnd, ID_EDIT1, str, sizeof(str) );
		st = strtol( str, NULL, 0 );
		ecfg->SetPsgLPF( st );
		
		// }X^[
		st = SendMessage( GetDlgItem( hwnd, ID_TBMST ), TBM_GETPOS, 0, 0 );
		ecfg->SetMasterVol( st*10 );
		
		// PSG
		st = SendMessage( GetDlgItem( hwnd, ID_TBPSG ), TBM_GETPOS, 0, 0 );
		ecfg->SetPsgVol( st*10 );
		
		// 
		st = SendMessage( GetDlgItem( hwnd, ID_TBVCE ), TBM_GETPOS, 0, 0 );
		ecfg->SetVoiceVol( st*10 );
		
		// TAPEj^
		st = SendMessage( GetDlgItem( hwnd, ID_TBTAPE ), TBM_GETPOS, 0, 0 );
		ecfg->SetCmtVol( st*10 );
		
		break;
		
	case PP_INPUT:	// ͊֌W
		// L[s[gԊu
		GetDlgItemText( hwnd, ID_KEYREP, str, sizeof(str) );
		st = strtol( str, NULL, 0 );
		ecfg->SetKeyRepeat( st );
		
		break;
		
	case PP_FOLDER:	// tH_
		// ROMpX
		GetDlgItemText( hwnd, ID_PATH1, str, sizeof(str) );
		ecfg->SetRomPath( str );
		
		// TAPEpX
		GetDlgItemText( hwnd, ID_PATH2, str, sizeof(str) );
		ecfg->SetTapePath( str );
		
		// DISKpX
		GetDlgItemText( hwnd, ID_PATH3, str, sizeof(str) );
		ecfg->SetDiskPath( str );
		
		// gROMpX
		GetDlgItemText( hwnd, ID_PATH4, str, sizeof(str) );
		ecfg->SetExtRomPath( str );
		
		// IMGpX
		GetDlgItemText( hwnd, ID_PATH5, str, sizeof(str) );
		ecfg->SetImgPath( str );
		
		// WAVEpX
		GetDlgItemText( hwnd, ID_PATH6, str, sizeof(str) );
		ecfg->SetWavePath( str );
		
		// FONTpX
		GetDlgItemText( hwnd, ID_PATH7, str, sizeof(str) );
		ecfg->SetFontPath( str );
		
		break;
		
	case PP_FILE:	// t@C
		// gROMt@C
		GetDlgItemText( hwnd, ID_FEXROM, str, sizeof(str) );
		ecfg->SetExtRomFile( str );
		
		// TAPE(LOAD)t@C
		GetDlgItemText( hwnd, ID_FTPLD, str, sizeof(str) );
		ecfg->SetTapeFile( str );
		
		// TAPE(SAVE)t@C
		GetDlgItemText( hwnd, ID_FTPSV, str, sizeof(str) );
		ecfg->SetSaveFile( str );
		
		// DISKt@C
		GetDlgItemText( hwnd, ID_FDISK, str, sizeof(str) );
		ecfg->SetDiskFile( str );
		
		// v^t@C
		GetDlgItemText( hwnd, ID_FPRINT, str, sizeof(str) );
		ecfg->SetPrinterFile( str );
		
		// SptHgt@C
		GetDlgItemText( hwnd, ID_FFONTZ, str, sizeof(str) );
		ecfg->SetFontFileZ( str );
		
		// ptHgt@C
		GetDlgItemText( hwnd, ID_FFONTH, str, sizeof(str) );
		ecfg->SetFontFileH( str );
		
		break;
		
	case PP_COL:	// F1
		break;
		
	case PP_ETC:	// ̑
		// I[o[NbN
		GetDlgItemText( hwnd, ID_OVERCLK, str, sizeof(str) );
		st = min( max( 1, strtol( str, NULL, 0 ) ), 1000 );
		ecfg->SetOverClock( st );
		
		// CRC`FbN
		ecfg->SetCheckCRC( IsDlgButtonChecked( hwnd, ID_CB4 ) );
		
		// ROMpb`
		ecfg->SetRomPatch( IsDlgButtonChecked( hwnd, ID_CB9 ) );
		
		// Turbo TAPE
		ecfg->SetTurboTAPE( IsDlgButtonChecked( hwnd, ID_CB9 ) );
		
		// Boost Up
		ecfg->SetBoostUp( IsDlgButtonChecked( hwnd, ID_CB5 ) );
		
		// BoostUp ő{(N60[h)
		GetDlgItemText( hwnd, ID_BOOST60, str, sizeof(str) );
		st = min( max( 1, strtol( str, NULL, 0 ) ), 100 );
		ecfg->SetMaxBoost1( st );
		
		// BoostUp ő{(N60m/N66[h)
		GetDlgItemText( hwnd, ID_BOOST62, str, sizeof(str) );
		st = min( max( 1, strtol( str, NULL, 0 ) ), 100 );
		ecfg->SetMaxBoost2( st );
		
		// rfILv` RLE
		ecfg->SetAviRle( IsDlgButtonChecked( hwnd, ID_CB6 ) );
		
		// I mF
		ecfg->SetCkQuit( IsDlgButtonChecked( hwnd, ID_CB8 ) );
		
		// I INIt@Cۑ
		ecfg->SetSaveQuit( IsDlgButtonChecked( hwnd, ID_CB12 ) );
		
		break;
	}
	
	return TRUE;
}


///////////////////////////////////////////////////////////
// ݒ_CAOvV[W
///////////////////////////////////////////////////////////
// {
static BOOL CALLBACK OsdCnfgProc1( HWND hwnd, UINT msg, WPARAM wp, LPARAM lp )
{
	switch( msg ){
	case WM_INITDIALOG:
		// ݒǍ
		if( !OsdReadINI( hwnd, PP_BASE ) ) OSD_Message( MSERR_IniReadFailed, MSERR_ERROR, OSDR_OK | OSDM_ICONERROR );
//		EnableWindow( GetDlgItem( hwnd, ID_CB1 ), SendMessage( GetDlgItem( hwnd, ID_RB01 ), BM_GETCHECK, 0, 0 ) );
		break;
		
	case WM_COMMAND:
/*
		switch( wp ){
		case ID_RB01:
			EnableWindow( GetDlgItem( hwnd, ID_CB1 ), TRUE );
			break;
			
		case ID_RB02:
		case ID_RB03:
		case ID_RB04:
		case ID_RB05:
			EnableWindow( GetDlgItem( hwnd, ID_CB1 ), FALSE );
		}
*/
		break;
		
	case WM_NOTIFY:
		switch( ((NMHDR *)lp)->code ){
		case PSN_APPLY:	// OK{^
			// ݒۑ
			if( !OsdWriteINI( hwnd, PP_BASE ) ) OSD_Message( MSERR_IniWriteFailed, MSERR_ERROR, OSDR_OK | OSDM_ICONERROR );
			return TRUE;
		}
	}
	return FALSE;
}

// 
static BOOL CALLBACK OsdCnfgProc2( HWND hwnd, UINT msg, WPARAM wp, LPARAM lp )
{
	switch( msg ){
	case WM_INITDIALOG:
		// ݒǍ
		if( !OsdReadINI( hwnd, PP_DISP ) ) OSD_Message( MSERR_IniReadFailed, MSERR_ERROR, OSDR_OK | OSDM_ICONERROR );
		break;
		
	case WM_COMMAND:
		break;
		
	case WM_NOTIFY:
		switch( ((NMHDR *)lp)->code ){
		case PSN_APPLY:
			// ݒۑ
			if( !OsdWriteINI( hwnd, PP_DISP ) ) OSD_Message( MSERR_IniWriteFailed, MSERR_ERROR, OSDR_OK | OSDM_ICONERROR );
			return TRUE;
		}
	}
	return FALSE;
}

// TEh
static BOOL CALLBACK OsdCnfgProc3( HWND hwnd, UINT msg, WPARAM wp, LPARAM lp )
{
	switch( msg ){
	case WM_INITDIALOG:
		// ݒǍ
		if( !OsdReadINI( hwnd, PP_SOUND ) ) OSD_Message( MSERR_IniReadFailed, MSERR_ERROR, OSDR_OK | OSDM_ICONERROR );
		break;
		
	case WM_NOTIFY:
		switch( ((NMHDR *)lp)->code ){
		case PSN_APPLY:
			// ݒۑ
			if( !OsdWriteINI( hwnd, PP_SOUND ) ) OSD_Message( MSERR_IniWriteFailed, MSERR_ERROR, OSDR_OK | OSDM_ICONERROR );
			return TRUE;
		}
	}
	return FALSE;
}

// t@C
static BOOL CALLBACK OsdCnfgProc4( HWND hwnd, UINT msg, WPARAM wp, LPARAM lp )
{
	switch( msg ){
	case WM_INITDIALOG:
		// ݒǍ
		if( !OsdReadINI( hwnd, PP_FILE ) ) OSD_Message( MSERR_IniReadFailed, MSERR_ERROR, OSDR_OK | OSDM_ICONERROR );
		break;
		
	case WM_COMMAND:
		char Folder[PATH_MAX];
		switch( wp ){
		case ID_B11:	// t@CQƃ{^(gROMC[W)
			GetDlgItemText( hwnd, ID_FEXROM, Folder, sizeof(Folder) );
			if( OSD_FileSelect( hwnd, FD_ExtRom, Folder, ecfg->GetExtRomPath() ) ){
				UnDelimiter( Folder );
				SetDlgItemText( hwnd, ID_FEXROM, Folder );
			}
			break;
			
		case ID_B12:	// t@CQƃ{^(TAPEC[W(LOAD))
			GetDlgItemText( hwnd, ID_FTPLD, Folder, sizeof(Folder) );
			if( OSD_FileSelect( hwnd, FD_TapeLoad, Folder, ecfg->GetTapePath() ) ){
				UnDelimiter( Folder );
				SetDlgItemText( hwnd, ID_FTPLD, Folder );
			}
			break;
			
		case ID_B13:	// t@CQƃ{^(TAPEC[W(SAVE))
			GetDlgItemText( hwnd, ID_FTPSV, Folder, sizeof(Folder) );
			if( OSD_FileSelect( hwnd, FD_TapeSave, Folder, ecfg->GetTapePath() ) ){
				UnDelimiter( Folder );
				SetDlgItemText( hwnd, ID_FTPSV, Folder );
			}
			break;
			
		case ID_B14:	// t@CQƃ{^(DISKC[W)
			GetDlgItemText( hwnd, ID_FDISK, Folder, sizeof(Folder) );
			if( OSD_FileSelect( hwnd, FD_Disk, Folder, ecfg->GetDiskPath() ) ){
				UnDelimiter( Folder );
				SetDlgItemText( hwnd, ID_FDISK, Folder );
			}
			break;
			
		case ID_B15:	// t@CQƃ{^(v^o̓t@C)
			GetDlgItemText( hwnd, ID_FPRINT, Folder, sizeof(Folder) );
			if( OSD_FileSelect( hwnd, FD_Printer, Folder, NULL ) ){
				UnDelimiter( Folder );
				SetDlgItemText( hwnd, ID_FPRINT, Folder );
			}
			break;
			
		case ID_B16:	// t@CQƃ{^(SptHgt@C)
			GetDlgItemText( hwnd, ID_FFONTZ, Folder, sizeof(Folder) );
			if( OSD_FileSelect( hwnd, FD_FontZ, Folder, ecfg->GetFontPath() ) ){
				UnDelimiter( Folder );
				SetDlgItemText( hwnd, ID_FFONTZ, Folder );
			}
			break;
			
		case ID_B17:	// t@CQƃ{^(ptHgt@C)
			GetDlgItemText( hwnd, ID_FFONTH, Folder, sizeof(Folder) );
			if( OSD_FileSelect( hwnd, FD_FontH, Folder, ecfg->GetFontPath() ) ){
				UnDelimiter( Folder );
				SetDlgItemText( hwnd, ID_FFONTH, Folder );
			}
			break;
		}
		break;
		
	case WM_NOTIFY:
		switch( ((NMHDR *)lp)->code ){
		case PSN_APPLY:
			// ݒۑ
			if( !OsdWriteINI( hwnd, PP_FILE ) ) OSD_Message( MSERR_IniWriteFailed, MSERR_ERROR, OSDR_OK | OSDM_ICONERROR );
			return TRUE;
		}
	}
	return FALSE;
}

// tH_
static BOOL CALLBACK OsdCnfgProc5( HWND hwnd, UINT msg, WPARAM wp, LPARAM lp )
{
	switch( msg ){
	case WM_INITDIALOG:
		// ݒǍ
		if( !OsdReadINI( hwnd, PP_FOLDER ) ) OSD_Message( MSERR_IniReadFailed, MSERR_ERROR, OSDR_OK | OSDM_ICONERROR );
		break;
		
	case WM_COMMAND:
		char Folder[PATH_MAX];
		switch( wp ){
		case ID_B01:	// tH_Qƃ{^(ROM)
			GetDlgItemText( hwnd, ID_PATH1, Folder, sizeof(Folder) );
			if( OSD_FolderDiaog( hwnd, Folder ) ) SetDlgItemText( hwnd, ID_PATH1, Folder );
			break;
			
		case ID_B02:	// tH_Qƃ{^(TAPE)
			GetDlgItemText( hwnd, ID_PATH2, Folder, sizeof(Folder) );
			if( OSD_FolderDiaog( hwnd, Folder ) ) SetDlgItemText( hwnd, ID_PATH2, Folder );
			break;
			
		case ID_B03:	// tH_Qƃ{^(DISK)
			GetDlgItemText( hwnd, ID_PATH3, Folder, sizeof(Folder) );
			if( OSD_FolderDiaog( hwnd, Folder ) ) SetDlgItemText( hwnd, ID_PATH3, Folder );
			break;
			
		case ID_B04:	// tH_Qƃ{^(gROM)
			GetDlgItemText( hwnd, ID_PATH4, Folder, sizeof(Folder) );
			if( OSD_FolderDiaog( hwnd, Folder ) ) SetDlgItemText( hwnd, ID_PATH4, Folder );
			break;
			
		case ID_B05:	// tH_Qƃ{^(IMG)
			GetDlgItemText( hwnd, ID_PATH5, Folder, sizeof(Folder) );
			if( OSD_FolderDiaog( hwnd, Folder ) ) SetDlgItemText( hwnd, ID_PATH5, Folder );
			break;
			
		case ID_B06:	// tH_Qƃ{^(WAVE)
			GetDlgItemText( hwnd, ID_PATH6, Folder, sizeof(Folder) );
			if( OSD_FolderDiaog( hwnd, Folder ) ) SetDlgItemText( hwnd, ID_PATH6, Folder );
			break;
			
		case ID_B07:	// tH_Qƃ{^(FONT)
			GetDlgItemText( hwnd, ID_PATH7, Folder, sizeof(Folder) );
			if( OSD_FolderDiaog( hwnd, Folder ) ) SetDlgItemText( hwnd, ID_PATH7, Folder );
			break;
		}
		break;
		
	case WM_NOTIFY:
		switch( ((NMHDR *)lp)->code ){
		case PSN_APPLY:
			// ݒۑ
			if( !OsdWriteINI( hwnd, PP_FOLDER ) ) OSD_Message( MSERR_IniWriteFailed, MSERR_ERROR, OSDR_OK | OSDM_ICONERROR );
			return TRUE;
		}
	}
	return FALSE;
}

// F1
static BOOL CALLBACK OsdCnfgProcCol( HWND hwnd, UINT msg, WPARAM wp, LPARAM lp )
{
	static COLORREF Color = 0;
	static COLORREF CustColors[16] = { RGB( 255, 255, 255 ), RGB( 255, 255, 255 ), RGB( 255, 255, 255 ), RGB( 255, 255, 255 ),
									   RGB( 255, 255, 255 ), RGB( 255, 255, 255 ), RGB( 255, 255, 255 ), RGB( 255, 255, 255 ),
									   RGB( 255, 255, 255 ), RGB( 255, 255, 255 ), RGB( 255, 255, 255 ), RGB( 255, 255, 255 ),
									   RGB( 255, 255, 255 ), RGB( 255, 255, 255 ), RGB( 255, 255, 255 ), RGB( 255, 255, 255 ) };
	static CHOOSECOLOR cc = { 0 };	// F̑Ip
	SDL_Color col;
	
	switch( msg ){
	case WM_INITDIALOG:
		// ݒǍ
		if( !OsdReadINI( hwnd, PP_COL ) ) OSD_Message( MSERR_IniReadFailed, MSERR_ERROR, OSDR_OK | OSDM_ICONERROR );
		
		// F̑I R_CAO 
		cc.lStructSize  = sizeof(CHOOSECOLOR);
		cc.hwndOwner    = hwnd;
		cc.rgbResult    = Color;
		cc.lpCustColors = CustColors;
		cc.Flags        = CC_FULLOPEN | CC_RGBINIT;
		
		break;
		
	case WM_DRAWITEM:	// I[i[h[
		if( wp >= ID_COL16 && wp < ID_COLMAX && ecfg->GetColor( wp-ID_COL00, &col ) ){
			// I[i[h[{^ `
			OsdOwnerDrawBtn( ((LPDRAWITEMSTRUCT)lp)->hDC,
							 ((LPDRAWITEMSTRUCT)lp)->rcItem,
							 RGB( col.r, col.g, col.b ) );
			return TRUE;
		}
		return FALSE;
		
	case WM_COMMAND:
		if( wp >= ID_COL15 && wp < ID_COLMAX && ecfg->GetColor( wp-ID_COL00, &col ) ){
			Color = RGB( col.r, col.g, col.b );
			// F̑I R_CAO\
			cc.rgbResult = Color;
			if( ChooseColor( &cc ) ){
				Color = cc.rgbResult;
				col.r = GetRValue( Color );
				col.g = GetGValue( Color );
				col.b = GetBValue( Color );
				ecfg->SetColor( wp-ID_COL00, &col );
				InvalidateRect( hwnd, NULL, TRUE );
			}
		}
		break;
		
	case WM_NOTIFY:
		switch( ((NMHDR *)lp)->code ){
		case PSN_APPLY:
			// ݒۑ
			if( !OsdWriteINI( hwnd, PP_COL ) ) OSD_Message( MSERR_IniWriteFailed, MSERR_ERROR, OSDR_OK | OSDM_ICONERROR );
			return TRUE;
		}
	}
	return FALSE;
}

// ̑
static BOOL CALLBACK OsdCnfgProcEtc( HWND hwnd, UINT msg, WPARAM wp, LPARAM lp )
{
	switch( msg ){
	case WM_INITDIALOG:
		// ݒǍ
		if( !OsdReadINI( hwnd, PP_ETC ) ) OSD_Message( MSERR_IniReadFailed, MSERR_ERROR, OSDR_OK | OSDM_ICONERROR );
		break;
		
	case WM_NOTIFY:
		switch( ((NMHDR *)lp)->code ){
		case PSN_APPLY:
			// ݒۑ
			if( !OsdWriteINI( hwnd, PP_ETC ) ) OSD_Message( MSERR_IniWriteFailed, MSERR_ERROR, OSDR_OK | OSDM_ICONERROR );
			return TRUE;
		}
	}
	return FALSE;
}

// ͊֌W
static BOOL CALLBACK OsdCnfgProcIn( HWND hwnd, UINT msg, WPARAM wp, LPARAM lp )
{
	switch( msg ){
	case WM_INITDIALOG:
		// ݒǍ
		if( !OsdReadINI( hwnd, PP_INPUT ) ) OSD_Message( MSERR_IniReadFailed, MSERR_ERROR, OSDR_OK | OSDM_ICONERROR );
		break;
		
	case WM_NOTIFY:
		switch( ((NMHDR *)lp)->code ){
		case PSN_APPLY:
			// ݒۑ
			if( !OsdWriteINI( hwnd, PP_INPUT ) ) OSD_Message( MSERR_IniWriteFailed, MSERR_ERROR, OSDR_OK | OSDM_ICONERROR );
			return TRUE;
		}
	}
	return FALSE;
}


// I[i[h[{^ `
static void OsdOwnerDrawBtn( HDC hdc, RECT rc, COLORREF col )
{
	HPEN hOldPen   = (HPEN)SelectObject( hdc, (HPEN)GetStockObject( BLACK_PEN ) );
	HBRUSH hBrs    = CreateSolidBrush( col );
	HBRUSH hOldBrs = (HBRUSH)SelectObject( hdc, hBrs );
	
	Rectangle( hdc, rc.left, rc.top, rc.right, rc.bottom );
	
	SelectObject( hdc, hOldPen );
	SelectObject( hdc, hOldBrs );
	DeleteObject( hBrs );
}



///////////////////////////////////////////////////////////
// o[W_CAOvV[W
///////////////////////////////////////////////////////////
static BOOL CALLBACK VerInfoProc( HWND hwnd, UINT msg, WPARAM wp, LPARAM lp )
{
	static HCURSOR hCursor = NULL;
	
	switch( msg ){
	case WM_INITDIALOG:
		{
		// o[Wݒ
		SetDlgItemText( hwnd, ID_VERSTR, APPNAME " Ver." VERSION );
		
		// ACRݒ
		const char *ilp;
		switch( ccfg->GetModel() ){
		case 62: ilp = MAKEINTRESOURCE(P62ICON); break;
		case 66: ilp = MAKEINTRESOURCE(P66ICON); break;
		case 64: ilp = MAKEINTRESOURCE(P64ICON); break;
		case 68: ilp = MAKEINTRESOURCE(P68ICON); break;
		default: ilp = MAKEINTRESOURCE(P60ICON);
		}
		HICON hNewIcon = LoadIcon( (HINSTANCE)GetWindowLong( hwnd, GWL_HINSTANCE), ilp );
		HICON hOldIcon = (HICON)SendMessage( GetDlgItem( hwnd, ID_VERICON ), STM_SETICON, (WPARAM)hNewIcon, 0 );
		if( hOldIcon ) DeleteObject( hOldIcon );
		
		// w^J[\擾
		HINSTANCE hInstHelp;
		char WinDir[MAX_PATH];
		
		GetWindowsDirectory( WinDir, MAX_PATH-13 );
		lstrcat( WinDir, "\\winhlp32.exe");
		hInstHelp = LoadLibrary( WinDir );
		if( hInstHelp ){
			hCursor = (HCURSOR)CopyImage( LoadImage( hInstHelp, MAKEINTRESOURCE(106), IMAGE_CURSOR, 0, 0, LR_DEFAULTCOLOR ), IMAGE_CURSOR, 0, 0, LR_COPYDELETEORG );
			FreeLibrary( hInstHelp );
		}else
			hCursor = (HCURSOR)LoadImage( NULL, IDC_ARROW, IMAGE_CURSOR, 0, 0, LR_DEFAULTCOLOR );
		break;
		}
	case WM_SETCURSOR:	// J[\ύX
		if( (HWND)wp == GetDlgItem( hwnd, ID_URL ) ){
			SetCursor( hCursor );
			SetWindowLong( hwnd, DWL_MSGRESULT, MAKELONG( TRUE, 0 ) );
			return TRUE;
		}
		return FALSE;
		break;
		
	case WM_CTLCOLORSTATIC:	// URL̐Fς
		{
		HDC hDC = (HDC)wp;
		if( (HWND)lp == GetDlgItem( hwnd, ID_URL ) ){
//			SelectObject( hDC, hFontHtml );		// tHgς
			SetTextColor( hDC, RGB(0,0,255) );	// Fς
			SetBkMode( hDC, TRANSPARENT );
			return (BOOL)(HBRUSH)GetStockObject( NULL_BRUSH );
		}
		return (BOOL)(HBRUSH)( COLOR_BTNFACE + 1 );
		}
		break;
		
	case WM_COMMAND:
    	switch( LOWORD(wp) ){
		case IDOK:
		case IDCANCEL:
			if( hCursor ) DestroyCursor( hCursor );	// J[\J
			EndDialog( hwnd, TRUE );
			break;
		case ID_URL:
			{
			char Url[256];
			GetWindowText( GetDlgItem( hwnd, ID_URL ), Url, 256 );
			ShellExecute( hwnd, "open", Url, NULL, NULL, SW_SHOWNORMAL );
			InvalidateRect( GetDlgItem( hwnd, ID_URL ), NULL, FALSE );
			return TRUE;
			}
		}
	}
	return FALSE;
}
